import React, {Component} from 'react';
import '../css/timpicker.css';
import ReactDOM from 'react-dom'
import LongHand from './clock-longhand-component';
import Ticks from './clock-ticks-component';


function _pad(value) {
    value = value.toString();
    return value.length === 1 ? "0" + value : value;
}

class Face extends Component {
    clickedHour = this.props.timepicker.hour
    clickedMinute = this.props.timepicker.minute

    componentDidMount() {
        var self = this;
        ReactDOM.findDOMNode(this.refs.face).addEventListener("transitionend", (e) => {
            if (e.propertyName === "opacity" && e.target.className.indexOf("face-hide") > -1) {
                if (self.props.type === 'hours')
                    self.props.onChangeTime(self.clickedHour, self.props.timepicker.minute, self.props.timepicker.am);
                if (self.props.type === 'minutes')
                    self.props.onChangeTime(self.props.timepicker.hour, self.clickedMinute, self.props.timepicker.am);
            }
        });
    }

    componentWillUnmount() {
        var self = this;
        ReactDOM.findDOMNode(this.refs.face).removeEventListener("transitionend", (e) => {
            if (e.propertyName === "opacity" && e.target.className.indexOf("face-hide") > -1)
                self.props.onChangeTime(self.clickedHour, self.clickedMinute, self.props.timepicker.am);
        });
    }

    render() {
        var self = this;
        return <div ref="face"
                    className={"face " + this.props.type + (this.props.selected ? " face-show" : " face-hide")}>
            {this.props.values.map(function (value, i) {
                return <div key={i}
                            className={"position position-" + (i + 1) + (parseInt(this.props.timepicker.hour) === parseInt(value) ? " selected" : "")}
                            onClick={ () => {
                                if (self.props.type === 'hours') {
                                    console.log('value in hour ', value)
                                    self.clickedHour = value;
                                    self.props.onHoursMinutesVisibilityChanged(false, true);
                                }
                                if (self.props.type === 'minutes') {
                                    console.log('value in minute     ', value)
                                    self.clickedMinute = value;
                                    self.props.hideClock();
                                    self.props.onHoursMinutesVisibilityChanged(false, false);
                                }
                            }  }>
                    {_pad(value)}
                </div>
            }.bind(this))}
            <LongHand type={this.props.type} selected={this.props.selected}/>
            <div className="inner-face"></div>
            <Ticks />
        </div>;
    }
}

export  default Face;