import React, {Component} from 'react';
import  {connect} from 'react-redux';
import Clock from '../components/clock-component';
import * as actions from '../action-creators';

const mapStateToProps = (store) => {
    console.log(store)
    return {
        timepicker: store.timepicker
    };
}

const mapDispatchToProps = (dispatch) => {
    return ({
        onChangeTime: (hour, minute, am) => {
            dispatch(actions.changeTime(hour, minute, am));
        },
        onHoursMinutesVisibilityChanged: (hoursVisible, minutesVisible) => {
            dispatch(actions.changeHoursMinutesVisibility(hoursVisible, minutesVisible))
        },
        hideClock: () => {
            console.log('calling jhide ')
            dispatch(actions.hideClock())
        }
    });
}
export default connect(mapStateToProps, mapDispatchToProps)(Clock);