import * as types from './action-types';

function _pad(value) {
    value = value.toString();
    return value.length === 1 ? "0" + value : value;
}

function _getTimeString(hour, minute, am) {
    return hour + ":" + _pad(minute) + " " + (am ? "AM" : "PM");
}


const initialState = {
    CLOCK_SIZE: 222,
    clockVisible: false,
    hour: 12,
    minute: 0,
    am: true,
    timeString: "12:00 AM",
    position: {
        top: 0,
        left: 0
    },
    hoursVisible: true,
    minutesVisible: false
};

const timepickerReducer = (state = initialState, action) => {
    console.log('action  ', action)
    switch (action.type) {
        case types.SHOW_CLOCK :
            return Object.assign({}, state, {clockVisible: true, position: action.position, hoursVisible: true});
        case types.HIDE_CLOCK:
            return Object.assign({}, state, {clockVisible: false});
        case types.CHANGE_TIME :
            return Object.assign({}, state, {
                hour: action.hour,
                minute: action.minute,
                am: action.am,
                timeString: _getTimeString(action.hour, action.minute, action.am)
            });
        case types.HOUR_MINUTE_VISIBLE :

            return Object.assign({}, state, {hoursVisible: action.hourVisible, minutesVisible: action.minuteVisible});
        default :
            return state;
    }

}

export  default timepickerReducer;